package cn.net.cpzslibs.prot.handset;

import com.google.gson.Gson;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.net.Socket;
import java.util.ArrayList;
import java.util.List;

import cn.net.cpzslibs.prot.ProtBase;
import cn.net.cpzslibs.prot.SocketCreate;
import cn.net.cpzslibs.prot.handset.bean.CarNumBean;
import cn.net.cpzslibs.prot.handset.bean.Prot10087ResBean;
import cn.net.cpzslibs.prot.utils.StrUtils;

public class Prot10087GetCarNumber extends ProtBase{
	/**
	 * 是否成功
	 */
	private short iResult;

	private final short iTaskCode10087 = 10087;
	private Gson gson;
	private Prot10087ResBean resBean;
	private List<CarNumBean> dealerList = new ArrayList<>();
	private boolean isEnd = false;//true：所有协议包已经请求完      false：服务器返回的数据还未接收完全

	public Prot10087GetCarNumber() {
		// this.sInspectorId = sInspectorId;
		gson = new Gson();
	}

	public Prot10087ResBean getResBean() {
		return this.resBean;
	}

	public void getCatNumList(SocketCreate create) throws IOException {
		recProt(create.getSocket(), create.getDos(), create.getDis());
	}

	private void recProt(Socket socket, DataOutputStream dos, DataInputStream dis)
			throws IOException {
		if (socket.isConnected()) {
			if (!socket.isOutputShutdown()) {
				// 发送登录信息
				debugLog(iTaskCode10087, "开始请求车牌号列表");
				sendProt(dos);
			}
		}
		if (socket.isConnected()) {
			if (!socket.isInputShutdown()) {
				while (!isEnd) {
					//服务器可能分多次包返回数据
					recLoginDis(dis);
				}
			}
		}
	}

//	static int cTest = 0;

	/**
	 * 读取JSon数据
	 * 
	 * @param dis
	 * @throws IOException
	 */
	private void recLoginDis(DataInputStream dis) throws IOException {
//		debugLog(iTaskCode20024, (cTest++) + "获取接收的数据");
		recHeader(dis);
		int jsonLength = getiRecBodySize() - 2;
		String jsonData = getUTF8(dis, jsonLength);
		debugLog(iTaskCode10087, jsonData);
		if (!StrUtils.isEmpty(jsonData)) {
			resBean = gson.fromJson(jsonData, Prot10087ResBean.class);
			
			if (resBean.getList() != null) {
				dealerList.addAll(resBean.getList());
			}
			if (resBean.getIndex() == 0) {
				//所有协议包已经请求完
				resBean.setList(dealerList);
				isEnd = true;
			}
			if (resBean.getResult() == 1) {
				//请求时遇到错误信息
				isEnd = true;
			}
		} else {
			isEnd = true;
		}

		recCheckCode(dis);
		
	}

	/**
	 * 发送JSon数据到服务器
	 * 
	 * @param dos
	 * @param iUserType
	 * @param loginBean
	 * @throws IOException
	 */
	private void sendProt(DataOutputStream dos) throws IOException {
//		String bodyContent = gson.toJson(productBean).toString();
		String bodyContent = "{}";
		short bodySize = countBodySize(bodyContent);
		sendHeader(dos, iTaskCode10087, bodySize);// 84
		dos.write(bodyContent.getBytes("UTF-8"));
		sendCheckCoded(dos, bodyContent.getBytes("UTF-8"));
	}

}
